#include "ap.h"


// Optimized fnt using table lookup for the powers of W

// void tablefnt (modint data[], modint wtable[], size_t ptable[], size_t nn, int s=1);
// void itablefnt (modint data[], modint wtable[], size_t ptable[], size_t nn, int s=1);

asm ("
    .globl _tablefnt
    .globl _itablefnt

.align 16
_tablefnt:
    subl $32, %esp
    pushl %ebx
    pushl %ecx
    pushl %edx
    pushl %esi
    pushl %edi
    pushl %ebp

    movl 60(%esp), %eax
    movl 72(%esp), %ebx
    shll $2, %ebx
    addl %ebx, %eax
    movl %ebx, 44(%esp)
    movl %eax, 52(%esp)
    movl $4, 32(%esp)

    movl _modulus, %ecx


    tablefntloop:
    movl 44(%esp), %eax
    shrl $1, %eax
    cmpl $4, %eax
    jb tablefntend
    movl %eax, 44(%esp)
    movl %eax, %ebx
    addl 60(%esp), %eax
    addl %ebx, %ebx
    movl %eax, 48(%esp)
    movl %ebx, 40(%esp)


    movl 60(%esp), %esi

    tablefntfor1:
    cmpl 52(%esp), %esi
    jae tablefntfor1end

    movl %esi, %edi
    addl 44(%esp), %edi

    movl (%esi), %edx
    movl (%edi), %ebx

    movl %edx, %eax

    addl %ebx, %edx
    cmpl %ecx, %edx
    jb tablefor1l1
    subl %ecx, %edx
    tablefor1l1:

    subl %ebx, %eax
    jnc tablefor1l3
    addl %ecx, %eax
    tablefor1l3:

    movl %edx, (%esi)
    movl %eax, (%edi)

    addl 40(%esp), %esi
    jmp tablefntfor1

    tablefntfor1end:


    movl 64(%esp), %ebp
    addl 32(%esp), %ebp

    movl 60(%esp), %eax
    addl $4, %eax

    tablefntfor2:
    cmpl 48(%esp), %eax
    jae tablefntfor2end

    movl %eax, 36(%esp)
    movl %eax, %esi

    tablefntfor3:
    cmpl 52(%esp), %esi
    jae tablefntfor3end

    movl %esi, %edi
    addl 44(%esp), %edi

    movl (%esi), %edx
    movl (%edi), %ebx

    movl %edx, %eax

    addl %ebx, %edx
    cmpl %ecx, %edx
    jb tablefor3l1
    subl %ecx, %edx
    tablefor3l1:

    subl %ebx, %eax
    jnc tablefor3l3
    addl %ecx, %eax
    tablefor3l3:

    movl %edx, (%esi)

    mull (%ebp)
    divl %ecx

    movl %edx, (%edi)

    addl 40(%esp), %esi
    jmp tablefntfor3

    tablefntfor3end:

    addl 32(%esp), %ebp

    movl 36(%esp), %eax
    addl $4, %eax
    jmp tablefntfor2

    tablefntfor2end:


    shll $1, 32(%esp)
    jmp tablefntloop


    tablefntend:

    cmpl $0, 76(%esp)
    je tablefntnos

    movl 68(%esp), %ebp
    movl 60(%esp), %ebx

    tablefntscramble:
    movl (%ebp), %esi
    movl 4(%ebp), %edi
    cmpl %esi, %edi
    je tablefntnos
    movl (%ebx, %esi, 4), %eax
    movl (%ebx, %edi, 4), %edx
    addl $8, %ebp
    movl %eax, (%ebx, %edi, 4)
    movl %edx, (%ebx, %esi, 4)
    jmp tablefntscramble

    tablefntnos:

    popl %ebp
    popl %edi
    popl %esi
    popl %edx
    popl %ecx
    popl %ebx
    addl $32, %esp

    ret

.align 16
_itablefnt:
    subl $32, %esp
    pushl %ebx
    pushl %ecx
    pushl %edx
    pushl %esi
    pushl %edi
    pushl %ebp

    cmpl $0, 76(%esp)
    je itablefntnos

    movl 68(%esp), %ebp
    movl 60(%esp), %ebx

    itablefntscramble:
    movl (%ebp), %esi
    movl 4(%ebp), %edi
    cmpl %esi, %edi
    je itablefntnos
    movl (%ebx, %esi, 4), %eax
    movl (%ebx, %edi, 4), %edx
    addl $8, %ebp
    movl %eax, (%ebx, %edi, 4)
    movl %edx, (%ebx, %esi, 4)
    jmp itablefntscramble

    itablefntnos:


    movl 60(%esp), %eax
    movl 72(%esp), %ebx
    shll $2, %ebx
    addl %ebx, %eax
    movl %ebx, 32(%esp)
    movl %eax, 52(%esp)
    movl $4, 44(%esp)

    movl _modulus, %ecx

    itablefntloop:
    movl 32(%esp), %eax
    shrl $1, %eax
    cmpl $4, %eax
    jb itablefntend
    movl %eax, 32(%esp)
    movl 44(%esp), %eax
    movl %eax, %ebx
    addl 60(%esp), %eax
    movl %eax, 48(%esp)
    addl %ebx, %ebx
    movl %ebx, 40(%esp)


    movl 60(%esp), %esi

    itablefntfor1:
    cmpl 52(%esp), %esi
    jae itablefntfor1end

    movl %esi, %edi
    addl 44(%esp), %edi

    movl (%esi), %edx
    movl (%edi), %ebx

    movl %edx, %eax

    addl %ebx, %edx
    cmpl %ecx, %edx
    jb itablefor1l1
    subl %ecx, %edx
    itablefor1l1:

    subl %ebx, %eax
    jnc itablefor1l3
    addl %ecx, %eax
    itablefor1l3:

    movl %edx, (%esi)
    movl %eax, (%edi)

    addl 40(%esp), %esi
    jmp itablefntfor1

    itablefntfor1end:


    movl 64(%esp), %ebp
    addl 32(%esp), %ebp

    movl 60(%esp), %eax
    addl $4, %eax

    itablefntfor2:
    cmpl 48(%esp), %eax
    jae itablefntfor2end

    movl %eax, 36(%esp)
    movl %eax, %esi

    itablefntfor3:
    cmpl 52(%esp), %esi
    jae itablefntfor3end

    movl %esi, %edi
    addl 44(%esp), %edi

    movl (%esi), %ebx
    movl (%ebp), %eax

    mull (%edi)
    divl %ecx

    movl %ebx, %eax

    addl %edx, %ebx
    cmpl %ecx, %ebx
    jb itablefor3l1
    subl %ecx, %ebx
    itablefor3l1:

    subl %edx, %eax
    jnc itablefor3l3
    addl %ecx, %eax
    itablefor3l3:

    movl %ebx, (%esi)
    movl %eax, (%edi)

    addl 40(%esp), %esi
    jmp itablefntfor3

    itablefntfor3end:

    addl 32(%esp), %ebp

    movl 36(%esp), %eax
    addl $4, %eax
    jmp itablefntfor2

    itablefntfor2end:


    shll $1, 44(%esp)
    jmp itablefntloop


    itablefntend:

    popl %ebp
    popl %edi
    popl %esi
    popl %edx
    popl %ecx
    popl %ebx
    addl $32, %esp

    ret
");
